require("defines")

UBS_table_one = {}
UBS_table_two = {}

local function Round(n)

	return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)

end

local function Flushtable()

	if UBS_table_two == {} then
		--'note to you, the code actually never runs to this part. it always goes to the else piece in this statement. have no idea why, but it works.'
		--the table contains no data, just flush table one to two and reproduce one as {}
		UBS_table_two = UBS_table_one
		UBS_table_one = {}
	else
		--the table contains data
		--go through the table data and check for neighbours, if not: print the message:
		--game.players[1].print("UBS has detected a disconnected basic underground belt at: " .. "X = " .. tostring(UBS_table_two[var_1].position.x) .. ", Y = " .. tostring(UBS_table_two[var_1].position.y) )
	
		for UBS_var_1 = 1, 100 do
			if UBS_table_two[UBS_var_1] then
				if UBS_table_two[UBS_var_1].valid then					--this cant be done, its invalid		--how to check if invalid
					if UBS_table_two[UBS_var_1].neighbours[1] == nil then
						if UBS_table_two[UBS_var_1].name == "basic-transport-belt-to-ground" then
							UBS_var4 = "basic"
						elseif UBS_table_two[UBS_var_1].name == "fast-transport-belt-to-ground" then
							UBS_var4 = "fast"
						elseif UBS_table_two[UBS_var_1].name == "express-transport-belt-to-ground" then
							UBS_var4 = "express"
						end
						game.players[1].print("UBS has detected a disconnected " .. UBS_var4 .. " underground belt at: " .. "X = " .. tostring(UBS_table_two[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table_two[UBS_var_1].position.y))
						UBS_var_detected = true
					else
						--a neighbour has been detected
					end
				end
			else
				if UBS_var_detected then game.players[1].print("You are now at: " .. "X = " .. tostring(Round(game.players[1].position.x)) .. ", Y = " .. tostring(Round(game.players[1].position.y))) UBS_var_detected = false end
				UBS_table_two = UBS_table_one
				UBS_table_one = {}
				break
			end
		end

	end

end

local function Basic_detection(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then
			if UBS_table[UBS_var_1].neighbours[1] == nil then
				game.players[1].print("UBS has detected a disconnected basic underground belt at: " .. "X = " .. tostring(UBS_table[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table[UBS_var_1].position.y) )
			else
				--a neighbour has been detected
			end
		else
			game.players[1].print("Detection has stopped, above this message you can see all the disconnected basic belts")
			game.players[1].print("You are now at: " .. "X = " .. tostring(Round(game.players[1].position.x)) .. ", Y = " .. tostring(Round(game.players[1].position.y)))
			break
		end
	end
end

local function Fast_detection(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then
			if UBS_table[UBS_var_1].neighbours[1] == nil then
				game.players[1].print("UBS has detected a disconnected fast underground belt at: " .. "X = " .. tostring(UBS_table[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table[UBS_var_1].position.y) )
			else
				--a neighbour has been detected
			end
		else
			game.players[1].print("Detection has stopped, above this message you can see all the disconnected fast belts")
			game.players[1].print("You are now at: " .. "X = " .. tostring(Round(game.players[1].position.x)) .. ", Y = " .. tostring(Round(game.players[1].position.y)))
			break
		end
	end
end

local function Express_detection(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then
			if UBS_table[UBS_var_1].neighbours[1] == nil then
				game.players[1].print("UBS has detected a disconnected express underground belt at: " .. "X = " .. tostring(UBS_table[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table[UBS_var_1].position.y) )
			else
				--a neighbour has been detected
			end
		else
			game.players[1].print("Detection has stopped, above this message you can see all the disconnected express belts")
			game.players[1].print("You are now at: " .. "X = " .. tostring(Round(game.players[1].position.x)) .. ", Y = " .. tostring(Round(game.players[1].position.y)))
			break
		end
	end
end

local function BuildTableBTPBTG()

		UBS_table_BTBTG = game.get_surface(1).find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "basic-transport-belt-to-ground"}
--		game.players[1].print("UBS: Table has been built, checking for non connected underground belts now.")
		Basic_detection(UBS_table_BTBTG)

end

local function BuildTableFTPBTG()

		UBS_table_FTBTG = game.surfaces["nauvis"].find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "fast-transport-belt-to-ground"}
--		game.players[1].print("UBS: Table has been built, checking for non connected underground belts now.")
		Fast_detection(UBS_table_FTBTG)


end

local function BuildTableETPBTG()

		UBS_table_ETBTG = game.surfaces["nauvis"].find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "express-transport-belt-to-ground"}
--		game.players[1].print("UBS: Table has been built, checking for non connected underground belts now.")
		Express_detection(UBS_table_ETBTG)


end

script.on_event(defines.events.on_tick, function(event)

	if not UBS_table_one then UBS_table_one = {} end
	if not UBS_table_two then UBS_table_two = {} end
	
	if not UBS_var_dns then
		if not UBS_var2 then
			UBS_var2 = 0
		end

		if UBS_var2 == 60 then
			if not game.players[1].gui.left.UBS_frame then
				game.players[1].gui.left.add{type = "frame", name = "UBS_frame", caption = "Do you want to check for non-connected underground belt?", direction = "vertical"}
				game.players[1].gui.left.UBS_frame.add{type = "label", name = "UBS_lbl_warning", caption = "Warning, this might take longer than 2 minutes, depending on the speed of your machine."}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_basic", caption = "Check basic belts"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_fast", caption = "Check fast belts"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_express", caption = "Check express belts"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_all", caption = "Check all belt types"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_not", caption = "Close"}
			end
		else
			UBS_var2 = UBS_var2 + 1
		end
	end

	if UBS_var_warningadded then
		if UBS_var3 then
			UBS_var3 = UBS_var3 + 1
		else
			UBS_var3 = 1
		end

		if UBS_var3 == 10 then
			UBS_var_warningadded = false
			BuildTableBTPBTG()
			BuildTableFTPBTG()
			BuildTableETPBTG()
			game.players[1].gui.center.UBS_frame_warning.destroy()
		end
	end

end)

script.on_event(defines.events.on_gui_click, function(event)
	if event.element.name == "UBS_button_basic" then
--		game.players[1].gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		BuildTableBTPBTG()
	elseif event.element.name == "UBS_button_fast" then
--		game.players[1].gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		BuildTableFTPBTG()
	elseif event.element.name == "UBS_button_express" then
--		game.players[1].gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		BuildTableETPBTG()
	elseif event.element.name == "UBS_button_all" then
--		game.players[1].gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		game.players[1].gui.center.add{type = "frame", name = "UBS_frame_warning", caption = "This might take a while"}
		game.players[1].gui.center.UBS_frame_warning.add{type = "label", name = "UBS_lbl_warning1", caption = "This will certainly take a long time, the game is going through 10.000.000.000 tiles three times to check if there are any disconnected underground belts, you better grab some coffee or a snack."}
--		game.players[1].print("This will certainly take a long time, the game is going through 10.000.000.000 tiles three time to check if there are any disconnected underground belts, you better grab some coffee or a snack. \n")
		UBS_var_warningadded = true
--		BuildTableBTPBTG()
--		BuildTableFTPBTG()
--		BuildTableETPBTG()
	elseif event.element.name == "UBS_button_not" then
		game.players[1].gui.left.UBS_frame.destroy()
		UBS_var_dns = true
	end
end)

script.on_event(defines.events.on_built_entity, function(event)

	if event.created_entity.type == "transport-belt-to-ground" then
		UBS_var_1 = 0
		while true do
		UBS_var_1 = UBS_var_1 + 1
			if UBS_table_one[UBS_var_1] then
				--this number already contains something
			else
				UBS_table_one[UBS_var_1] = event.created_entity
				--game.players[1].print("UBS_var_1 = " .. tostring(UBS_var_1))
				if UBS_var_1 >= 20 then
					game.players[1].print("Flushing table")
					Flushtable()
				end
				break
			end
		end
	end

end)
--]]